# -*- coding: utf-8 -*-
"""
Created on Mon May 17 14:39:42 2021

@author: Ame
"""

from astropy.io import fits
from oitools import oimodel as oim
import numpy as np

mas2rad=np.pi/180/3600./1000.


fname="D:\\Downloads\\output_Be_1621254088385.fits"
fname="D:\\Downloads\\output_Be_1621255760518.fits"
fname="D:\\Downloads\\output_Be_1621339408746.fits"#VHIGH
fname="D:\\Downloads\\output_Be_1621339750258.fits"#GRAVITY
fname="D:\\Downloads\\output_Be_1621342493228.fits"#MED
fname="D:\\Downloads\\output_Be_1621342647911.fits" #20A
fname_out='D:\\Downloads\\output_Be_20A.fits'

data=fits.open(fname)
data[0].header["CUNIT1"]="rad"
data[0].header["CUNIT2"]="rad"
data[0].header["CUNIT3"]="m"


er=oim.oim_eskewring(d=17,elong=1.5,pa=0,skw=1,pa2=180)
g=oim.oim_gauss(fwhm=2)
cv=oim.oim_convolution(er, g)
m=oim.oim_model([cv])

pix=data[0].header["CDELT1"]/mas2rad
dim=data[0].header["NAXIS1"]


im0=m.getImage(dim,pix)[0,:,:]

nwl=data[0].header["NAXIS3"]

ratio=0.2

for iwl in range(nwl):
    data[0].data[iwl,:,:]=ratio* data[0].data[iwl,:,:]+(1-ratio)*im0
    

data.writeto(fname_out,overwrite=True)